Index: examples/creddy_prover_tests/access_rt2/README
===================================================================
--- examples/creddy_prover_tests/access_rt2/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/access_rt2/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -27,5 +27,5 @@
 # proj2.
 
-# access_rt2_typed
+# access_rt2
 
 # alpha.access(Read,fileA)<-?-bob  good
Index: examples/creddy_prover_tests/access_rt2/run_query
===================================================================
--- examples/creddy_prover_tests/access_rt2/run_query	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/access_rt2/run_query	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -11,4 +11,6 @@
 bob=`creddy --keyid --cert $keyloc/Bob_ID.pem`
 joe=`creddy --keyid --cert $keyloc/Joe_ID.pem`
+
+print $eloc/abac_prover_yap
 
 bob_prin="[keyid:$bob]"
Index: examples/creddy_prover_tests/acme_friend_rt1/README
===================================================================
--- examples/creddy_prover_tests/acme_friend_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/acme_friend_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -22,5 +22,5 @@
 # does).
 
-# acme_friend_rt1_typed
+# acme_friend_rt1
 
 #[keyid:Acme].role:friendof([keyid:Roadrunner]) <-?- [keyid:Coyote] (no)
Index: examples/creddy_prover_tests/acme_rockets_intersection_rt0/README
===================================================================
--- examples/creddy_prover_tests/acme_rockets_intersection_rt0/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/acme_rockets_intersection_rt0/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -35,5 +35,5 @@
 #
 
-# acme_rockets_intersection_rt0_typed
+# acme_rockets_intersection_rt0
 
 creddy --generate --cn Acme
Index: examples/creddy_prover_tests/acme_rockets_rt0/README
===================================================================
--- examples/creddy_prover_tests/acme_rockets_rt0/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/acme_rockets_rt0/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -14,5 +14,5 @@
 # something other than a principal works (it doesn't).
 
-# acme_rockets_rt0_typed
+# acme_rockets_rt0
 
 creddy --generate --cn Acme
Index: examples/creddy_prover_tests/alice_rt1/README
===================================================================
--- examples/creddy_prover_tests/alice_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/alice_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -3,5 +3,5 @@
 ## trying out different data param types
 
-# alice_rt1_typed
+# alice_rt1
 
 creddy --generate --cn Alice
Index: examples/creddy_prover_tests/alumni2_rt1/README
===================================================================
--- examples/creddy_prover_tests/alumni2_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/alumni2_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -17,5 +17,5 @@
 # alums, and only Bob is.
 
-# alumni2_rt1_typeD
+# alumni2_rt1
 
 # [keyid:stateU].role:foundingAlumni <-?- [keyid:Bob] (yes)
Index: examples/creddy_prover_tests/alumni3_rt1/README
===================================================================
--- examples/creddy_prover_tests/alumni3_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/alumni3_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -16,5 +16,5 @@
 # alums, and only Bob and Jan are.
 
-# alumni3_rt1_typed
+# alumni3_rt1
 
 rm -rf *.der *.pem
Index: examples/creddy_prover_tests/alumni_rt1/README
===================================================================
--- examples/creddy_prover_tests/alumni_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/alumni_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -16,5 +16,5 @@
 # alums and Joe and Maryann are.
 
-# alumni_rt1_typed
+# alumni_rt1
 
 # [keyid:stateU].role:foundingAlumni <-?- [keyid:Bob] (no)
Index: examples/creddy_prover_tests/balltime_rt2/README
===================================================================
--- examples/creddy_prover_tests/balltime_rt2/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/balltime_rt2/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -30,5 +30,5 @@
 # stadium's free-for-all early morning time
 
-# balltime_rt2_typed
+# balltime_rt2
 
 creddy --generate --cn League
Index: examples/creddy_prover_tests/evaluator_rt1/README
===================================================================
--- examples/creddy_prover_tests/evaluator_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/evaluator_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -16,5 +16,5 @@
 # ISI employee.
 
-# evaluator_rt1_typed
+# evaluator_rt1
 
 #[keyid:USC].role:employee <-?- [keyid:John]
Index: examples/creddy_prover_tests/experiment_create_rt0/README
===================================================================
--- examples/creddy_prover_tests/experiment_create_rt0/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/experiment_create_rt0/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -25,5 +25,5 @@
 #
 
-# experiment_create_rt0_typed 
+# experiment_create_rt0 
 
 creddy --generate --cn Acme
Index: examples/creddy_prover_tests/file_read_rt2/README
===================================================================
--- examples/creddy_prover_tests/file_read_rt2/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/file_read_rt2/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -21,5 +21,5 @@
 # fileA, then it confirms that Maryann cannot. 
 
-# file_read_rt2_typed
+# file_read_rt2
 
 # alpha.read(fileA) <-?- Bob
Index: examples/creddy_prover_tests/fruits_rt2/README
===================================================================
--- examples/creddy_prover_tests/fruits_rt2/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/fruits_rt2/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -23,5 +23,5 @@
 # 1.50 (we don't know anything about green apples).
 
-# fruits_rt2_typed
+# fruits_rt2
 
 # mary.what2eat<-?-navel orange  good
Index: examples/creddy_prover_tests/leader_rt1/README
===================================================================
--- examples/creddy_prover_tests/leader_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/leader_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -18,5 +18,5 @@
 # rule from Bob to him.
 
-# leader_rt1_typed
+# leader_rt1
 
 # [keyid:geni].role:leader <-?- [keyid:Bob] (yes)
Index: examples/creddy_prover_tests/payraise_rt1/README
===================================================================
--- examples/creddy_prover_tests/payraise_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/payraise_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -22,5 +22,5 @@
 # did not affirm his pleasantness(but neither did he deny it)
 
-rm -rf *der *pem
+# payraise_rt1
 
 # [keyid:Alpha].role:payRaise <-?- [keyid:Maryann] (yes)
Index: examples/creddy_prover_tests/runall
===================================================================
--- examples/creddy_prover_tests/runall	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/runall	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -14,5 +14,11 @@
 fi
 
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
+
+UID=`id | sed -e 's/ .*//' | sed -e 's/.*(//' | sed -e 's/)//'`
+if [ $UID = "mei" ]; then
+    ABAC_PROVER_PATH="../../../libabac"
+    else
+    ABAC_PROVER_PATH=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+fi
 export ABAC_PROVER_PATH
 
Index: examples/creddy_prover_tests/runcheck
===================================================================
--- examples/creddy_prover_tests/runcheck	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/creddy_prover_tests/runcheck	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -3,5 +3,10 @@
 rm -rf allout.cn allout.sha
 
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
+UID=`id | sed -e 's/ .*//' | sed -e 's/.*(//' | sed -e 's/)//'`
+if [ $UID = "mei" ]; then
+    ABAC_PROVER_PATH="../../../libabac"
+    else
+    ABAC_PROVER_PATH=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+fi
 export ABAC_PROVER_PATH
 
Index: examples/python_tests/access_rt2/README
===================================================================
--- examples/python_tests/access_rt2/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/access_rt2/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,4 +1,3 @@
 #####################################################################
-# access_rt2
 # This example demonstrates using an oset (object set) to control access
 # to files based on the attributes of the principals.  The script creates
@@ -8,9 +7,9 @@
 # 
 # A principal's access rights are controlled by the Alpha principal.  If a 
-# principal has the role role::aceess(string:'Read', urn:filename) that 
+# principal has the role role::acess(string:'Read', urn:filename) that 
 # principal can Read filename.  
 # The policy names 2 teams, proj1 and proj1.  A principal is on proj1 if it
 # has the role team(string:'proj1') defined by Alpha (written
-# [keyid:Alpha}.role:team(string:'proj1')).  Each project has an associated set
+# [keyid:Alpha].role:team(string:'proj1')).  Each project has an associated set
 # of files, defined by object sets.  A file is in proj1's documents if it is in
 # the oset of documents('proj1') defined by Alpha, written
@@ -25,4 +24,7 @@
 # fileA, then it confirms that Joe cannot.  Finally it confirms that Joe is in
 # proj2.
+
+# access_rt2
+
 # Credential 1
 #[keyid:alpha].role:access([string:'Read'],
@@ -35,7 +37,2 @@
 # Credential 4
 # [keyid:alpha].role:team([string:'proj2'])<-[keyid:Joe]
-creddy --attribute \
-        --issuer Alpha_ID.pem --key Alpha_private.pem \
-        --role "team([string:'proj2'])" \
-        --subject-cert Joe_ID.pem \
-        --out Alpha_team_proj2__Joe_attr.der
Index: examples/python_tests/access_rt2/attr.py
===================================================================
--- examples/python_tests/access_rt2/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/access_rt2/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,23 +2,22 @@
 
 """
-  to test with python
+See README in this directory for the semantics of the example.  This file
+creates a principal(Joe) and constructs the credentials described and puts 
+copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
 """
 
-# See README in this directory for the semantics of the example.  This file
-# constructs the credentials described and puts copies into this directory
-
 import os
 import ABAC
-
-# Keystore is the directory containing the principal credentials.
-keystore=os.environ["keystore"]
 
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-# Load existing principals
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
 
 # Print the principals and credentials in the keystore
@@ -42,8 +41,8 @@
 joeID.id_write_privkey("Joe_private.pem")
 joeID.id_write_cert("Joe_ID.pem")
-# Keep a copy if Joe's key identifier as a string.
+# Keep a copy of Joe's key identifier as a string.
 joe=joeID.id_keyid()
 
-# Load alpha and bob from local files (created by ./setup.py
+# Load alpha and bob from local files (created by ./setup.py)
 alphaID=ABAC.ID("Alpha_ID.pem")
 alphaID.id_load_privkey_file("Alpha_private.pem");
@@ -133,7 +132,7 @@
 attr.attribute_write_cert("Alpha_access_qFqP__alpha_team_qP_attr.der")
 ctxt.load_attribute(attr)
-#print attr.string() 
-#print attr.typed_string()
-#print "\n"
+print attr.string() 
+print attr.typed_string()
+print "\n"
 
 
@@ -154,4 +153,2 @@
 print "\n"
 
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/access_rt2/query.py
===================================================================
--- examples/python_tests/access_rt2/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/access_rt2/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -12,14 +12,14 @@
 import ABAC
 
-# Run the queries described in README
-
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
-
-# If a keystore is given in the environment, pre-load those credentials
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1) 
 
 # Load the principals created in ./attr.py and ./setup.py.  Each has an
@@ -27,10 +27,8 @@
 alphaID=ABAC.ID("Alpha_ID.pem");
 alphaID.id_load_privkey_file("Alpha_private.pem");
-#ctxt.load_id(alphaID)
 alpha=alphaID.id_keyid()
 
 bobID=ABAC.ID("Bob_ID.pem");
 bobID.id_load_privkey_file("Bob_private.pem");
-#ctxt.load_id(bobID)
 bob=bobID.id_keyid()
 
@@ -39,4 +37,17 @@
 joe=joeID.id_keyid()
 
+##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
 # Construct and run the queries.  In each case we create a role object and a
 # principal and call the query method on the context.  The contents of the
@@ -90,17 +101,2 @@
     print "%s <- %s" % (c.head_string(), c.tail_string())
 
-
-##########################################################################
-# dump the loaded principals/policies 
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
-
Index: examples/python_tests/access_rt2/run_test
===================================================================
--- examples/python_tests/access_rt2/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/access_rt2/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,7 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
-
 
 echo '---setup principals'
Index: examples/python_tests/access_rt2/setup.py
===================================================================
--- examples/python_tests/access_rt2/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/access_rt2/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,13 +2,10 @@
 
 """
-  to test with python
-
+See README for the semantics.  This creates two of three prinicpals 
+(Alpha and Bob) used by the example. 
 
 """
 import os
 import ABAC
-
-# See README for the semantics.  This creates two prinicpals (Alpha and Bob)
-# used by the example.  The ./attrs.py file creates the policy credentials.
 
 ctxt = ABAC.Context()
Index: examples/python_tests/acme_friend_rt1/README
===================================================================
--- examples/python_tests/acme_friend_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_friend_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 # This example shows how a parameterized role can be used to infer a role and
 # that the same role can also be directly assigned.  The example has 4
-# principals, the Acme company, a Coyote, a RoadRUnner and a Jackrabbit.
+# principals, the Acme company, a Coyote, a RoadRunner and a Jackrabbit.
 #
 # The policy of the Acme company is that anyone the Acme company thinks is a
@@ -9,33 +9,27 @@
 # customer has the [keyid:Acme].role:preferred_customer role.
 #
-# This script creates the 4 and 3 credentials.  Credential 1 lays out the rule
+# setup.py script creates the 4 principal: Acme, Coyote, Roadrunner and 
+# Jackrabbit.
+# attr.py script creates 3 policy credentials,  Credential 1 lays out the rule
 # that friends of the Roadrunner are preferred customers.  Credential 2
 # directly makes the Coyote a preferred customer.  Credential 3 recognizes that
 # Acme thinks that the Jackrabbit is the Roadrunner's friend.
 # 
-# The attached ./run_query script tests whether the coyote is a friend of the
-# Roadrunner (which fails), whether the Jackrabbit is a friend of teh
+# The query.py script tests whether the coyote is a friend of the
+# Roadrunner (which fails), whether the Jackrabbit is a friend of the
 # Roadrunner (which succeeds), whether the Jackrabbit is a preferred customer
 # (which succeeds), whether the Coyote is a prefered customer (succeeds for a
 # different reason) and whether the system fails to load a bad certificate (it
 # does).
-
+#
 # acme_friend_rt1
-
-#[keyid:Acme].role:friendof([keyid:Roadrunner]) <-?- [keyid:Coyote] (no)
-#[keyid:Acme].role:preferred_customer <-?- [keyid:Jackrabbit] (yes)
-
-creddy --generate --cn Acme
-creddy --generate --cn Coyote
-creddy --generate --cn Roadrunner
-creddy --generate --cn Jackrabbit
-
-roadrunner_keyid=`creddy --keyid --cert Roadrunner_ID.pem`
-friendof_roadrunner="friendOf([keyid:$roadrunner_keyid])"
-
+#
+# Credential 1
 #[keyid:Acme].role:preferred_customer <- [keyid:Acme].role:friendOf([keyid:Roadrunner])
 
+# Credential 2
 #[keyid:Acme].role:prefered_customer <- [keyid:Coyote]
 
+# Credential 3
 #[keyid:Acme].role:friendOf([keyid:Roadrunner]) <- [keyid:Jackrabbit]
 
Index: examples/python_tests/acme_friend_rt1/attr.py
===================================================================
--- examples/python_tests/acme_friend_rt1/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_friend_rt1/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,8 +2,8 @@
 
 """
-  Setup access policy attribute rules
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
-
 """
 
@@ -11,10 +11,12 @@
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
 
 out = ctxt.context_principals()
@@ -30,4 +32,5 @@
 print "\n"
 
+# retrieve principals' keyid value from local credential files
 acmeID=ABAC.ID("Acme_ID.pem")
 acmeID.id_load_privkey_file("Acme_private.pem");
@@ -47,14 +50,25 @@
 
 ################################################
+# Credential 1 
 # [keyid:Acme].role:preferred_customer <- [keyid:Acme].role:friendof([keyid:Roadrunner])
 head = ABAC.Role(acme,"preferred_customer")
 param=ABAC.DataTerm(roadrunnerID)
 tail = ABAC.Role(acme,"friendof")
+
+# adding parameter to friendOf role
 tail.role_add_data_term(param)
+
+# link the head and tail parts of attribute together
 attr=ABAC.Attribute(head, 1800)
 attr.attribute_add_tail(tail)
+
+# finalize the attribute
 attr.attribute_bake()
+
+# write to file system to be accessible later on
 attr.attribute_write_cert("Acme_preferred_customer__Acme_friendof_Roadrunner_attr.der")
-#ctxt.load_attribute_file("Acme_preferred_customer__Acme_friendof_Roadrunner_attr.der")
+
+# load the credential just made into the context directly
+# (bypass the external credential file)
 ctxt.load_attribute(attr)
 print attr.string() 
@@ -63,4 +77,5 @@
 
 #################################################
+# Credential 2
 # [keyid:Acme].role:prefered_customer <- [keyid:Coyote]
 head = ABAC.Role(acme,"preferred_customer")
@@ -70,5 +85,4 @@
 attr.attribute_bake()
 attr.attribute_write_cert("Acme_preferred_customer__Coyote_attr.der")
-#ctxt.load_attribute_file("Acme_preferred_customer__Coyote_attr.der")
 ctxt.load_attribute(attr)
 print attr.string() 
@@ -77,4 +91,5 @@
 
 #################################################
+# Credential 3
 # [keyid:Acme].role:friendof([keyid:Roadrunner]) <- [keyid:Jackrabbit]
 param=ABAC.DataTerm(roadrunnerID)
@@ -86,5 +101,4 @@
 attr.attribute_bake()
 attr.attribute_write_cert("Acme_friendof_Roadrunner__Jackrabbit_attr.der")
-#ctxt.load_attribute_file("Acme_friendof_Roadrunner__Jackrabbit_attr.der")
 ctxt.load_attribute(attr)
 print attr.string() 
@@ -92,4 +106,2 @@
 print "\n"
 
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/acme_friend_rt1/friend.save
===================================================================
--- examples/python_tests/acme_friend_rt1/friend.save	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_friend_rt1/friend.save	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,3 +1,14 @@
 % Restoring file /usr/local/lib/Yap/startup.yss
+
+...final principal set...
+(pAcme,keyid,y) 
+(pCoyote,keyid,y) 
+(pJackrabbit,keyid,y) 
+(pRoadrunner,keyid,y) 
+
+...final policy attribute set...
+pAcme.friendof(pRoadrunner) <- pJackrabbit
+pAcme.preferred_customer <- pAcme.friendof(pRoadrunner)
+pAcme.preferred_customer <- pCoyote
 
 ===bad============ Acme.friendOf(Roadrunner) <- Coyote
@@ -17,16 +28,4 @@
 pAcme.preferred_customer <- pCoyote
 
-...final principal set...
-(pAcme,keyid,y) 
-(pCoyote,keyid,y) 
-(pJackrabbit,keyid,y) 
-(pRoadrunner,keyid,y) 
-
-
-
-...final policy attribute set...
-pAcme.friendof(pRoadrunner) <- pJackrabbit
-pAcme.preferred_customer <- pAcme.friendof(pRoadrunner)
-pAcme.preferred_customer <- pCoyote
-
-
+===bad============ Acme.preferred_customer <- badcoyote
+fail, query's call got bad aspect names .. 
Index: examples/python_tests/acme_friend_rt1/query.py
===================================================================
--- examples/python_tests/acme_friend_rt1/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_friend_rt1/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,9 +2,8 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
 cmd2: env ABAC_CN=1 keystore=`pwd` ./query.py
-
 """
 
@@ -14,10 +13,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# extract principal's keyid from local principal cert files
 acmeID=ABAC.ID("Acme_ID.pem")
 acmeID.id_load_privkey_file("Acme_private.pem");
@@ -37,4 +40,17 @@
 
 ##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
+# is coyote a friend of roadrunner?
 # role =[keyid:Acme].role:friendof([keyid:Roadrunner]) 
 # p= [keyid:Coyote]
@@ -50,4 +66,5 @@
 
 ##########################################################################
+# is jackrabbit a friend of roadrunner ?
 # role =[keyid:Acme].role:friendof([keyid:Roadrunner]) 
 # p= [keyid:Jackrabbit]
@@ -64,4 +81,5 @@
 
 ##########################################################################
+# is jackrabbit a preferred_customer of Acme ?
 # role =[keyid:Acme].role:preferred_customer
 # p =[keyid:Jackrabbit]
@@ -75,4 +93,5 @@
 
 ##########################################################################
+# is coyote a preferred_customer of Acme ?
 # role =[keyid:Acme].role:preferred_customer
 # p =[keyid:Coyote]
@@ -86,16 +105,16 @@
 
 
+##########################################################################
+# is blah_blah a preferred_customer of Acme ?
+# role =[keyid:Acme].role:preferred_customer
+# p =[keyid:badCoyote]
+role = ABAC.Role(acme,"preferred_customer")
+# some random SHA keyid value
+badcoyote="1fb66793d453226f0b93a48c7f6ae0d51632e628"
+p = ABAC.Role(badcoyote)
+print "\n===bad============ Acme.preferred_customer <- badcoyote"
+out = ctxt.query(role, p)
 
-##########################################################################
-# dump the loaded principals/policies
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
 for c in out[1]:
     print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
+
Index: examples/python_tests/acme_friend_rt1/run_test
===================================================================
--- examples/python_tests/acme_friend_rt1/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_friend_rt1/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,6 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
 
 echo '---setup principals'
Index: examples/python_tests/acme_friend_rt1/setup.py
===================================================================
--- examples/python_tests/acme_friend_rt1/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_friend_rt1/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,7 +2,6 @@
 
 """
-  Setup 4 principal ID credentials
-
-  Acme, Coyote, Roadrunner and Jackrabbit
+See README for the semantics.  This creates 4 prinicpals (Acme, Coyote,
+Roadrunner and Jackrabbit) used by the example.  
 
 """
Index: examples/python_tests/acme_rockets_intersection_rt0/README
===================================================================
--- examples/python_tests/acme_rockets_intersection_rt0/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_intersection_rt0/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,4 +1,4 @@
 #
-# This example demonstrates intersections.  An intersection is a logical and of
+# This example demonstrates intersections.  An intersection is a logical-AND of
 # roles or osets.  An intersection succeeds if the principal is in the
 # intersection of the sets defined by the roles.
@@ -25,6 +25,15 @@
 #    Acme.buy_rockets <-?- Batman
 # 
-# Acme.buy_rockets <- Acme.preferred_customer & WarnerBros.character
-# Acme.preferred_customer <- Coyote
-# Acme.preferred_customer <- Batman
-# WarnerBros.character <- Coyote
+# acme_rockets_intersection_rt0
+
+# Credential 1
+#[keyid:Acme].role:buy_rockets <- [keyid:Acme].role:preferred_customer 
+                                    & [keyid:WarnerBros].role:charater
+# Credential 2
+# [keyid:Acme].role:preferred_customer <- [keyid:Coyote]
+
+# Credential 3
+#[keyid:Acme].role:preferred_customer <- [keyid:Batman]
+
+# Credential 4
+#[keyid:WarnerBros].role:character <- [keyid:Coyote]
Index: examples/python_tests/acme_rockets_intersection_rt0/attr.py
===================================================================
--- examples/python_tests/acme_rockets_intersection_rt0/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_intersection_rt0/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,17 +2,22 @@
 
 """
-  Setup access policy attribute rules
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
-
 """
 import os
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+
+# retrieve principals' keyid value from local credential files
 acmeID=ABAC.ID("Acme_ID.pem");
 acmeID.id_load_privkey_file("Acme_private.pem");
@@ -37,4 +42,6 @@
 
 ################################################
+# Credential 1, establish the intersection rule on who can buy
+# rockets from Acme
 #[keyid:Acme].role:buy_rockets <- [keyid:Acme].role:preferred_customer 
 #                                    & [keyid:WarnerBros].role:charater
@@ -43,8 +50,17 @@
 tail2 = ABAC.Role(warnerbros,"character")
 attr=ABAC.Attribute(head, 1800)
+
+# to add intersection, just add multiple tails, make sure they are all
+# roles or all osets
 attr.attribute_add_tail(tail1)
 attr.attribute_add_tail(tail2)
+
+# finalize the rule
 attr.attribute_bake()
+
+# save it out as external credential file
 attr.attribute_write_cert("Acme_buy_rockets__Acme_preferred_customer_and_WarnerBros_character_attr.der")
+
+# load it into context from the just created credential file
 ctxt.load_attribute_file("Acme_buy_rockets__Acme_preferred_customer_and_WarnerBros_character_attr.der")
 print attr.string() 
@@ -53,4 +69,5 @@
 
 #################################################
+# Credential 2
 #[keyid:Acme].role:preferred_customer <- [keyid:Coyote]
 head = ABAC.Role(acme,"preferred_customer")
@@ -66,4 +83,5 @@
 
 #################################################
+# Credential 3
 #[keyid:Acme].role:preferred_customer <- [keyid:Batman]
 head = ABAC.Role(acme,"preferred_customer")
@@ -80,4 +98,5 @@
 
 ################################################
+# Credential 4
 #[keyid:WarnerBros].role:character <- [keyid:Coyote]
 head=ABAC.Role(warnerbros,"character")
@@ -87,10 +106,9 @@
 attr.attribute_bake()
 attr.attribute_write_cert("WarnerBros_character__Coyote_attr.der")
-#ctxt.load_attribute_file("WarnerBros_character__Coyote_attr.der")
+
+# demonstrate how attribute can be load from structure insted of a file
 ctxt.load_attribute(attr)
-#print attr.string() 
-#print attr.typed_string()
-#print "\n"
+print attr.string() 
+print attr.typed_string()
+print "\n"
 
-ctxt.dump_yap_db()
-##
